/*
  xrus - keyboard switcher/indicator
  Copyright (c) 1996 Alexander V. Lukyanov
  This is free software with no warranty.
  See COPYING for details.
*/
#include <config.h>
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <Xm/RowColumn.h>
#include <Xm/PushB.h>
#include <Xm/Separator.h>
#include <Xm/CascadeB.h>

#include "xrus.h"
#include "menu.h"
#include "props.h"
#include "altmap.h"

Widget   menu;
Widget   menus[2]={0,0};

enum
{
   LOCK,
   PROPS,
   EXIT
};

static
void  menu_item_cb(Widget w,XtPointer closure,XtPointer call_data)
{
   switch((int)closure)
   {
   case LOCK:
      LockScreen();
      break;
   case PROPS:
      PropsPopup();
      break;
   case EXIT:
      cleanup();
      XtDestroyApplicationContext(app_context);
      app_context=NULL;
      break;
   }
}

static
XtCallbackRec  menu_cb[]=
{
   {menu_item_cb,0},
   {NULL}
};

static
void  popup_create(int n)
{
   Arg   args[2];
   int   count=0;

   Widget   altmap_menu;

   if((menu=menus[n])!=NULL)
      return;

   AddArg(XtNmappedWhenManaged,False);
   menu=menus[n]=XmCreatePopupMenu(switch_button[n],"menu",args,count);

   menu_cb[0].closure=(XtPointer)LOCK;
   XtVaCreateManagedWidget("lock",xmPushButtonWidgetClass,menu,XmNactivateCallback,menu_cb,NULL);
   menu_cb[0].closure=(XtPointer)PROPS;
   XtVaCreateManagedWidget("props",xmPushButtonWidgetClass,menu,XmNactivateCallback,menu_cb,NULL);

   altmap_menu=CreateAltMapMenu(menu,AppData.altMaps);
   if(altmap_menu)
   {
      XtVaCreateManagedWidget("altmap",xmCascadeButtonWidgetClass,menu,
         XmNsubMenuId,altmap_menu,
         NULL);
   }

   XtVaCreateManagedWidget("line",xmSeparatorWidgetClass,menu,NULL);
   menu_cb[0].closure=(XtPointer)EXIT;
   XtVaCreateManagedWidget("exit",xmPushButtonWidgetClass,menu,XmNactivateCallback,menu_cb,NULL);
}

static
void  popup_menu(XEvent *ev)
{
   XmMenuPosition(menu,&(ev->xbutton));
   XtManageChild(menu);
}

void  XrusMenuCreate()
{
   popup_create(0);
   popup_create(1);
}

void  XrusMenuPopup(Widget w,XEvent *ev,String *params, Cardinal *num_params)
{
   popup_create(w==switch_button[1]);
   if((menus[0] && XtIsManaged(menu)) || (menus[1] && XtIsManaged(menus[1])))
      return;
   popup_menu(ev);
}
